;; Copyright 2016, 2017 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------
(defun ac-tex-macros-list ()
  (let ((orig-point (point))
        ret)
    (save-excursion
      (goto-char (point-min))
      (while (skip-chars-forward "^%\\\\")
        (if (equal (char-after) ?%)
               (end-of-line)
          (let ((p (point)))
            (when (equal 1 (mod (skip-chars-forward "\\\\") 2))
              
              ((looking-at "\\(\\\\\\\\\\)+")
               (goto-char (match-end 0)))
              
      (while (re-search-forward "\
\\(\\\\\\\\\\)*\
\\(\
\\\\\\([a-zA-Z]+\\)\
\\|\
%.*\
\\)"
                                nil t)
        (cond ((match-beginning 3)
               ;; \foo macro name
               (unless (and (>= orig-point (match-beginning 3))
                            (<= orig-point (match-end 3)))
                 (add-to-list 'ret (buffer-substring (1- (match-beginning 3))
                                                     (match-end 3)))))
              (t
               ;; % comment
               (end-of-line)))))
    (nreverse ret)))

;;-----------------------------------------------------------------------------

(require 'ac-tex-macros)
(make-local-variable 'ac-sources)
(add-to-list 'ac-sources 'ac-source-tex-macros)

\flah


;;-----------------------------------------------------------------------------
;; ac-tex-macros-beginning-of-macro-position

(goto-char (ac-tex-macros-beginning-of-macro-position))

\foo
\\foo
\\\foo

\blah
\flah
