;; Copyright 2009, 2010, 2011, 2014 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------
(progn
  (add-to-list 'load-path "~/lisp")
  (require 'ffap-href))

(autoload 'ffap-href-enable "ffap-href" nil t)
(eval-after-load "ffap" '(ffap-href-enable))
(ffap-href-enable)
(require 'ffap)

<a href="http://localhost/index.html">text</a>
<a href='http://local&lt;host/index.html'>text</a>
<a href='../repo.html'>text</a>
<a charset="iso-8859-1" href='../repo.html'>text</a>
<img src='../repo.html'>

(ffap-href-unentitize "&lt;")
(ffap-href-unentitize "&laquo;&amp;lt;")
(ffap-href-unentitize "&#247;")
(ffap-href-unentitize "&#8888;")
(ffap-href-unentitize "&#255;")
(setq debug-on-error t)

(with-temp-buffer
  buffer-undo-list)
(string-match "[^<>]" "\n")

;;-----------------

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

(progn
  (switch-to-buffer "x")
  (mapc (lambda (elem)
          (let ((want (car elem))
                (str  (cadr elem)))
            (erase-buffer)
            (insert str)
            (goto-char (point-min))
            (while (not (eobp))
              (let ((got (thing-at-point 'ffap-href)))
                (or (string-equal want got)
                    (error "Unexpected: %s" got)))
              (forward-char))))
        '(("/etc/passwd"
           "<a type=\"application/octet-stream\" href=\"/etc/passwd\" class=1>\n")
          ("/etc/passwd"
           "<a href='/etc/passwd'>\n")
          ("/etc/passwd"
           "<a href='/etc/passwd'")
          ("/etc/passwd"
           "<a type=\"application/octet-stream\" href=\"/tmp/\\\"\">\n")))
  "ok")


;;-----------------------------------------------------------------------------

;; <base class=1 href='/sxome/where/'>
;; <base hxref="/some/where">

(defun ffap-href-base ()
  "Return <base href=\"/some/where\"> location."
  (save-excursion
    (let ((case-fold-search t))
      (goto-char (point-min))
      (and (re-search-forward "\
<base\
\\(?:\\s-\\|\n\\)\
\\(?:[^>]+\\(?:\\s-\\|\n\\)\\)?\
href=\
\\(?:\"\\([^\"]*\\)\"\\|'\\([^']*\\)'\\)"
			      nil t)
	   (or (match-string 1)
	       (match-string 2))))))

(defun ffap-href-expand (link)
  (let ((base (or (ffap-href-base) "")))
    (if (string-match "\\(\\(.\\|\n\\)*/\\)" base)
	(concat (match-string 1 base) link)
      link)))

