;; Copyright 2008, 2009, 2010, 2012, 2014 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.



(unload-feature 'imagetext)
(let ((image (create-image "/home/gg/lisp/test/imagetext/screenshot.png")))
  (ignore-errors (kill-buffer "xx"))
  (switch-to-buffer "xx")
  (text-mode)
  (insert "\nxx\nyy\nzz\n")
  (insert-image image)
  (insert "\nxx\nyy\nzz\n")
  (insert-image image)
  (insert "\nxx\nyy\nzz\n")
  (insert-image image)
  (insert "\nxx\nyy\nzz\n")
  (scroll-1-view-keybindings)
  (goto-char (point-min))
  (view-mode)
  (define-key (current-local-map) [f10] 'my-next-line))

(defun my-next-line ()
  (interactive)
  (let ((old ))
    (set-window-vscroll nil (+ (window-vscroll nil t) 5) t)
    (message "old %S new %S" old (window-vscroll nil t))))

(defun my-next-line ()
  (interactive)
  (let* ((old-point (window-start))
         (old-y     (cdr (nth 2 (posn-at-point old-point))))
         (new-point (progn
                      ;; (scroll-up 1)
                      ;; (window-start)
                      (save-excursion
                        (goto-char old-point)
                        (forward-visible-line 1)
                        (point))))
         (new-y     (progn
                      ;; (set-window-start nil old-point)
                      (message "%S" (posn-at-point new-point))
                      (cdr (nth 2 (posn-at-point new-point)))))
         (this-height (- new-y old-y))
         (line-height (/ (float (frame-pixel-height)) (frame-height)))
         (old-vscroll (window-vscroll nil t)))
    (message "line-height %S" line-height)
    (if (or (not new-y)
            (and (> this-height (* 2 line-height))
                 (< (+ old-vscroll line-height) (- this-height line-height))))
        (set-window-vscroll nil (+ old-vscroll line-height) t)
      (set-window-start nil new-point))
    (message "old point %S vscroll %S  new point %S vscroll %S"
             old-point old-vscroll
             new-point (window-vscroll nil t))))



(cdr (nth 2 old-posn))
(cdr (nth 2 new-posn))

))
(#<window 14 on xx> right-fringe (640 . 0) 0 nil 12 (0 . 0) nil (0 . 0) (0 . 503))
(defun my-next-line ()
  (interactive)
  (next-line 1 1))

   (let ((height 0))
     (save-restriction
       (narrow-to-region (line-beginning-position) (line-end-position))
       (goto-char (point-min))
       (while (progn
                (let ((image (plist-get (get-text-property (point) 'display)
                                        'image)))
                  (when (eq 'image (car-safe image))
                    (setq height (max height (cdr (image-size image))))))
                (goto-char (or (next-single-property-change (point) 'display)
                               (point-max)))
                (not (eobp)))))
     (message "height %S" height))


   '(let ((scroll-preserve-screen-position t)
          (old (window-vscroll)))
      (set-window-vscroll nil (- old 0.5))
      (message "old %S new %S" old (window-vscroll))))
  '(let ((scroll-preserve-screen-position t)
         (old (window-vscroll)))
     (set-window-vscroll nil (+ old 0.5))
     (message "old %S new %S" old (window-vscroll))))


;;-----------------------------------------------------------------------------

(progn
  (add-to-list 'load-path (expand-file-name ".."))

  (autoload 'scroll-1-keybinding "scroll-1" nil t)
  (add-hook 'view-mode-hook 'scroll-1-view-keybinding)

  (view-mode))

(customize-variable 'view-mode-hook)
(normal-mode)

;;-----------------

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------------------------------------------------------------------

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "../scroll-1.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))

;;-----------------------------------------------------------------------------
;; apropos-mode

(add-hook 'apropos-mode-hook 'scroll-1-keybindings)
(setq debug-on-error t)
(add-hook 'apropos-mode-hook
          (lambda ()
            (message "hook ...")
            '(message "%S" major-mode)
            '(message "%s %s" major-mode (current-local-map))))
(apropos "auto-fill")

;;-----------------------------------------------------------------------------
