;; Copyright 2006, 2008, 2009, 2010, 2014 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;; Extract all url-link settings from defcustoms and check them with the
;; "linkchecker" program.


;; (defun cmp (x y)
;;   (string-lessp (if (symbolp x)
;;                     (symbol-name x)
;;                   x)
;;                 (if (symbolp y)
;;                     (symbol-name y)
;;                   y)))

;; (defun mung (loads)
;;   (cons 'progn
;;         (mapcar (lambda (load)
;;                (if (symbolp load)
;;                    `(require ',load)
;;                  `(load ,load)))
;;              loads)))

;; (progn
;;   (require 'pp)
;;   (find-file "custom-loads.out")
;;   (erase-buffer)
;;   (let ((lst nil))
;;     (mapatoms (lambda (symbol)
;;                 (let ((loads (get symbol 'custom-loads)))
;;                   (if loads
;;                       (add-to-list 'lst loads)))))

;;     (dolist (loads lst)
;;       (pp (mung loads) (current-buffer)))))
            

(defun my-custom-url-link ()
  (require 'info-xref)
  (pop-to-buffer info-xref-output-buffer t)
  (let ((info-xref-filename-heading "")
        url-links)
    (info-xref-output "\nChecking custom url-link ...\n")

    (mapatoms
     (lambda (symbol)
       (dolist (link (get symbol 'custom-links))
         (when (eq 'url-link (car link))
           ;; skip :tag part
           (if (eq :tag (cadr link))
               (setq link (cddr link)))

           (let ((url (cadr link)))
             (info-xref-output "`%s' in %s:\n    %s\n"
                               symbol (symbol-file symbol) (cadr link))
             (setq url-links (cons url url-links)))))))

    (apply 'call-process
           "linkchecker" nil info-xref-output-buffer t
           "-r0" "--no-status" url-links)))


(setq message-log-max 10000)
(progn
  (require 'ffap)
  (symbol-plist 'ffap)
  (get 'ffap 'custom-links)
  (assq 'url-link (get 'ffap 'custom-links)))

(progn
  (unless (featurep 'my-load-all)
    (load (expand-file-name "my-load-all.el")))
  (my-load-all--custom))

(my-custom-url-link)
