;; Copyright 2012 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------

(progn
  (defun factorial (n)
    (let ((ret 1))
      (dotimes (i n) ;; i=0 to i=n-1 inclusive
        (setq ret (* ret (1+ i))))
      ret))
  (factorial 5)
  )

(progn
  (defun factorial (n)
    (apply '* (number-sequence 1 n)))
  (factorial 5)
  )

(require 'calc)
(calc-eval "fact(30)")

(progn
  (require 'cl)
  (defun factorial (n)
    (apply '* (loop for i from 2 to n collect i)))
  (factorial 5)
  )

;;   16 15 14 13
;;    5  4  3 12
;;    6  1  2 11
;;    7  8  9 10
(defun number-spiral (n)
  (let* ((numwidth (length (number-to-string (* n n))))
         (fmt (format "%%%dd " numwidth))
         (value 0)
         (dx 1)
         (dy 0))
    (loop for sidelen from 1 to n do
          (loop repeat (if (= sidelen n) 1 2) do
                (loop repeat sidelen do
                      (insert (format fmt (incf value)))
                      (forward-line dy)
                      (setq dx (- dy)
                            dy dx))))))
(number-spiral 4)
