;; Copyright 2009 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

         ;; ".*?" for no backtracking is about 20% faster in emacs23.
         ;;

(setq compilation-error-regexp-alist-alist
      (remove* 'compilation-perl--Test2
               compilation-error-regexp-alist-alist
               :key 'car))

(let (result)
  (defun my-cdr->= (x y)
    (>= (cdr x) (cdr y)))

  (require 'compile)
  (with-temp-buffer
    (dotimes (i 5000)
      (insert "foo "))
    (insert "\n")

    (goto-char (point-min))
    (dolist (elem compilation-error-regexp-alist-alist)
      (let ((symbol (nth 0 elem))
            (regexp (nth 1 elem))
            (t1     (current-time))
            d)
        (looking-at regexp)
        (setq d (current-time))
        (setq d (* 1000 (float-time (subtract-time d t1))))
        (push (cons symbol d) result))))

  (setq result (sort result 'my-cdr->=))
  (save-excursion
    (goto-char (point-max))
    (pp result (current-buffer)))
  nil)

((gnu . 33.0)
 (perl--Test2 . 24.296000000000003)
 (perl--Test::Harness . 24.137999999999998)
 (compilation-perl--xsubpp . 21.46)
 (compilation-perl--Test2 . 19.956000000000003)
 (compilation-perl--Test . 19.838)
 (irix . 11.994)
 (msft . 11.450999999999999)
 (watcom . 11.435)
 (java . 0.163)
 (absoft . 0.154)
 (caml . 0.15100000000000002)
 (sun . 0.13799999999999998)
 (borland . 0.127)
 (ant . 0.122)
 (sparc-pascal-file . 0.12000000000000001)
 (makepp . 0.11900000000000001)
 (oracle . 0.112)
 (gcc-include . 0.108)
 (4bsd . 0.102)
 (compilation-perl-backtrace-long . 0.101)
 (weblint . 0.1)
 (comma . 0.096)
 (compilation-perl--Test::Builder . 0.093)
 (ibm . 0.093)
 (sun-ada . 0.093)
 (compilation-emacs21-batch . 0.091)
 (ftnchek . 0.089)
 (compilation-perl--Pod::Simple . 0.088)
 (perl--Pod::Checker . 0.087)
 (edg-1 . 0.08600000000000001)
 (epc . 0.085)
 (rxp . 0.085)
 (jikes-line . 0.08399999999999999)
 (compilation-perl-backtrace-short . 0.083)
 (bash . 0.081)
 (ada . 0.08)
 (compilation-ledger . 0.078)
 (perl . 0.078)
 (aix . 0.076)
 (php . 0.075)
 (perl--Test . 0.075)
 (sparc-pascal-line . 0.074)
 (iar . 0.07200000000000001)
 (lcc . 0.06999999999999999)
 (gcov-header . 0.06999999999999999)
 (gcov-nomark . 0.06899999999999999)
 (edg-2 . 0.068)
 (jikes-file . 0.068)
 (omake . 0.067)
 (gcov-called-line . 0.066)
 (sparc-pascal-example . 0.064)
 (gcov-file . 0.063)
 (gcov-never-called . 0.062)
 (mips-1 . 0.055)
 (mips-2 . 0.055))
