;; Copyright 2014, 2016, 2017 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))

(defun my-run-test ()
  (require 'miscbits-el-loaddefs)
  (let ((count 0)
        (tempbuf "*t-ac-tex-macros-used--temp*"))
    (switch-to-buffer tempbuf)

    (require 'ac-tex-macros-used)

    ;; ;;-------------------------------------------------------------------------
    ;; ;; safe-local-variable-p
    ;;
    ;; (if (not (fboundp 'safe-local-variable-p))
    ;;     (message "skip, no `safe-local-variable-p'")
    ;;
    ;;   (unless (safe-local-variable-p 'ac-tex-macros-ignore '("foo" "bar"))
    ;;     (error "ac-tex-macros-ignore not safe-local-variable-p"))
    ;;   (setq count (1+ count)))


    ;;-------------------------------------------------------------------------
    ;; ac-tex-macros-used-list

    (mapcar (lambda (elem)
              (let ((str  (nth 0 elem))
                    (pos  (nth 1 elem))
                    (want (nth 2 elem)))
                (erase-buffer)
                (insert str)
                (goto-char (+ (point-min) pos))
                (let ((got (ac-tex-macros-used-list)))
                  (unless (equal got want)
                    (save-excursion
                      (goto-char (point-max))
                      (insert "\n\n\n")
                      (insert (format "\n\nac-tex-macros-used-list\ngot:  %S\nwant: %S\nat count %S"
                                      got want count)))
                    (error "ac-tex-macros-used-list\ngot:  %S\nwant: %S\nat count %S"
                           got want count))))
              (setq count (1+ count)))

            '(
              ;; LaTeX
              ("\\foo" 0 ("\\foo"))

              ;; not ac-tex-macros-ignore
              ("\\documentclass{article} \\author \\date" 0 nil)

              ("\\foo \\bar" 4 ("\\bar"))  ;; not macro name at point
              ("\n% \\foo"       0 nil)        ;; not commented out
              ("\n\\% \\foo"     0 ("\\foo"))  ;; \% not a comment
              ("\n\\\\% \\foo"   0 nil)        ;; \\% is a comment
              ("\n\\\\\\% \\foo" 0 ("\\foo"))  ;; \\\% not a comment

              ("\n\\\\foo"     0 nil)        ;; not double backslashed
              ("\n\\\\\\foo"   0 ("\\foo"))  ;; yes triple
              ("\n\\\\\\\\foo" 0 nil)        ;; not quadruple
              ))


    ;;-------------------------------------------------------------------------
    ;; unload-feature

    ;; couple of cycles
    (require 'ac-tex-macros-used)
    (unload-feature 'ac-tex-macros-used t)
    (require 'ac-tex-macros-used)
    (unload-feature 'ac-tex-macros-used t)
    (setq count (1+ count))


    ;;-------------------------------------------------------------------------

    (bury-buffer)
    (message "  %d tests" count)
    count))
